
/*  A Bison parser, made from gst.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	BANG	257
#define	COLON	258
#define	UPARROW	259
#define	DOT	260
#define	ASSIGN	261
#define	SHARP	262
#define	SEMICOLON	263
#define	OPEN_PAREN	264
#define	CLOSE_PAREN	265
#define	OPEN_BRACKET	266
#define	CLOSE_BRACKET	267
#define	PRIMITIVE_START	268
#define	INTERNAL_TOKEN	269
#define	IDENTIFIER	270
#define	KEYWORD	271
#define	STRING_LITERAL	272
#define	SYMBOL_KEYWORD	273
#define	BINOP	274
#define	VERTICAL_BAR	275
#define	INTEGER_LITERAL	276
#define	BYTE_LITERAL	277
#define	FLOATING_LITERAL	278
#define	CHAR_LITERAL	279
#define	LARGE_INTEGER_LITERAL	280

#line 34 "gst.y"

#include "gst.h"
#include "sym.h"
#include "tree.h"
#include "dict.h"
#include "comp.h"
#include "lex.h"
#include "lib.h"
#include <stdio.h>
#if defined(STDC_HEADERS)
#include <string.h>
#endif

#define YYPRINT(file, type, value)   yyprint (file, type, &value)

#define YYDEBUG 1


#line 61 "gst.y"
typedef union{
  char		cval;
  double	fval;
  long		ival;
  char		*sval;
  ByteObject	boval;
  TreeNode	node;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		155
#define	YYFLAG		-32768
#define	YYNTBASE	27

#define YYTRANSLATE(x) ((unsigned)(x) <= 280 ? yytranslate[x] : 77)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     6,     8,    10,    13,    15,    19,    24,
    26,    30,    33,    36,    40,    45,    47,    50,    52,    54,
    56,    58,    60,    62,    65,    69,    71,    72,    76,    80,
    82,    83,    86,    90,    92,    95,    96,    98,   102,   104,
   108,   111,   115,   116,   118,   120,   123,   126,   130,   132,
   134,   136,   138,   140,   142,   146,   148,   150,   152,   154,
   156,   158,   160,   162,   164,   166,   169,   172,   174,   176,
   178,   180,   182,   184,   187,   190,   193,   197,   199,   202,
   204,   206,   208,   210,   213,   217,   219,   222,   228,   229,
   232,   235,   239,   241,   243,   245,   248,   250,   252,   256,
   258,   260,   263,   266,   270,   273,   276,   280,   282,   285
};

static const short yyrhs[] = {    28,
    33,     0,    29,     0,     0,    15,     0,    30,     0,    29,
    30,     0,    31,     0,    31,    28,     3,     0,    31,    28,
    32,     3,     0,     3,     0,    42,    44,     3,     0,     1,
     3,     0,    33,     3,     0,    32,    33,     3,     0,    34,
    42,    40,    44,     0,    35,     0,    36,    37,     0,    38,
     0,     1,     0,    16,     0,    20,     0,    21,     0,    16,
     0,    39,    37,     0,    38,    39,    37,     0,    17,     0,
     0,    14,    22,    41,     0,    14,    23,    41,     0,    20,
     0,     0,    21,    21,     0,    21,    43,    21,     0,    37,
     0,    43,    37,     0,     0,    45,     0,     5,    47,    46,
     0,    47,     0,    47,     6,    44,     0,     1,     3,     0,
     1,     6,    44,     0,     0,     6,     0,    49,     0,    48,
    49,     0,    37,     7,     0,    48,    37,     7,     0,    50,
     0,    67,     0,    74,     0,    37,     0,    51,     0,    64,
     0,    10,    47,    11,     0,    52,     0,    53,     0,    54,
     0,    56,     0,    57,     0,    58,     0,    22,     0,    24,
     0,    26,     0,    23,     0,     8,    55,     0,     8,    18,
     0,    16,     0,    36,     0,    19,     0,    17,     0,    25,
     0,    18,     0,     8,    59,     0,     8,    62,     0,    10,
    11,     0,    10,    60,    11,     0,    61,     0,    60,    61,
     0,    59,     0,    62,     0,    51,     0,    55,     0,    12,
    13,     0,    12,    63,    13,     0,    53,     0,    63,    53,
     0,    12,    65,    42,    44,    13,     0,     0,    66,    36,
     0,     4,    37,     0,    66,     4,    37,     0,    68,     0,
    70,     0,    72,     0,    69,    35,     0,    50,     0,    68,
     0,    71,    36,    69,     0,    69,     0,    70,     0,    71,
    73,     0,    39,    71,     0,    73,    39,    71,     0,    67,
    75,     0,     9,    76,     0,    75,     9,    76,     0,    35,
     0,    36,    69,     0,    73,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    99,   101,   102,   105,   109,   111,   114,   116,   117,   121,
   123,   130,   134,   146,   159,   165,   167,   168,   169,   176,
   180,   182,   185,   189,   191,   196,   200,   202,   203,   206,
   208,   210,   211,   215,   217,   221,   223,   226,   230,   231,
   234,   238,   244,   246,   249,   251,   254,   256,   261,   263,
   264,   267,   269,   270,   271,   274,   276,   277,   278,   279,
   280,   283,   285,   286,   289,   292,   294,   297,   299,   300,
   301,   305,   309,   313,   315,   318,   320,   324,   326,   331,
   333,   334,   335,   338,   340,   344,   346,   351,   356,   358,
   371,   373,   378,   380,   381,   384,   388,   390,   393,   398,
   400,   403,   408,   411,   416,   421,   423,   428,   430,   432
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","BANG","COLON",
"UPARROW","DOT","ASSIGN","SHARP","SEMICOLON","OPEN_PAREN","CLOSE_PAREN","OPEN_BRACKET",
"CLOSE_BRACKET","PRIMITIVE_START","INTERNAL_TOKEN","IDENTIFIER","KEYWORD","STRING_LITERAL",
"SYMBOL_KEYWORD","BINOP","VERTICAL_BAR","INTEGER_LITERAL","BYTE_LITERAL","FLOATING_LITERAL",
"CHAR_LITERAL","LARGE_INTEGER_LITERAL","program","internal_marker","file_in",
"doit_and_method_list","doit","method_list","method","message_pattern","unary_selector",
"binary_selector","variable_name","keyword_variable_list","keyword","primitive",
"primitive_end","temporaries","variable_names","statements","non_empty_statements",
"optional_dot","expression","assigns","simple_expression","primary","literal",
"number","small_number","symbol_constant","symbol","character_constant","string",
"array_constant","array","array_constant_list","array_constant_elt","byte_array",
"byte_array_constant_list","block","opt_block_variables","block_variable_list",
"message_expression","unary_expression","unary_object_description","binary_expression",
"binary_object_description","keyword_expression","keyword_binary_object_description_list",
"cascaded_message_expression","semi_message_list","message_elt", NULL
};
#endif

static const short yyr1[] = {     0,
    27,    27,    27,    28,    29,    29,    30,    30,    30,    31,
    31,    31,    32,    32,    33,    34,    34,    34,    34,    35,
    36,    36,    37,    38,    38,    39,    40,    40,    40,    41,
    42,    42,    42,    43,    43,    44,    44,    45,    45,    45,
    45,    45,    46,    46,    47,    47,    48,    48,    49,    49,
    49,    50,    50,    50,    50,    51,    51,    51,    51,    51,
    51,    52,    52,    52,    53,    54,    54,    55,    55,    55,
    55,    56,    57,    58,    58,    59,    59,    60,    60,    61,
    61,    61,    61,    62,    62,    63,    63,    64,    65,    65,
    66,    66,    67,    67,    67,    68,    69,    69,    70,    71,
    71,    72,    73,    73,    74,    75,    75,    76,    76,    76
};

static const short yyr2[] = {     0,
     2,     1,     0,     1,     1,     2,     1,     3,     4,     1,
     3,     2,     2,     3,     4,     1,     2,     1,     1,     1,
     1,     1,     1,     2,     3,     1,     0,     3,     3,     1,
     0,     2,     3,     1,     2,     0,     1,     3,     1,     3,
     2,     3,     0,     1,     1,     2,     2,     3,     1,     1,
     1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
     1,     1,     1,     2,     2,     2,     3,     1,     2,     1,
     1,     1,     1,     2,     3,     1,     2,     5,     0,     2,
     2,     3,     1,     1,     1,     2,     1,     1,     3,     1,
     1,     2,     2,     3,     2,     2,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,    10,     4,     0,     0,     0,     5,     7,     0,    12,
    23,    32,    34,     0,    19,    20,    26,    21,    22,     1,
    31,    16,     0,    18,     0,     6,     0,     0,     0,     0,
     0,    89,    73,    62,    65,    63,    72,    64,    52,     0,
    37,    39,     0,    45,    49,    53,    56,    57,    58,    59,
    60,    61,    54,    50,    93,   100,    94,     0,    95,    51,
    33,    35,    27,    17,     0,    24,     8,     0,     0,    41,
     0,    43,     0,     0,    68,    71,    67,    70,    69,    66,
    74,    75,     0,     0,    31,     0,    47,    11,     0,    52,
    46,     0,   105,    96,     0,     0,   102,     0,     0,    25,
     9,     0,    13,    42,    44,    38,    76,    82,    83,    80,
     0,    78,    81,    84,    86,     0,    55,    91,     0,     0,
    90,    40,    48,   108,     0,   110,   106,     0,    52,    97,
    98,    99,   101,   103,     0,     0,     0,    15,    14,    77,
    79,    85,    87,     0,    92,   109,   107,   104,    30,    28,
    29,    88,     0,     0,     0
};

static const short yydefgoto[] = {   153,
     5,     6,     7,     8,    68,    20,    21,    22,    23,    39,
    24,    25,    99,   150,     9,    14,    40,    41,   106,    42,
    43,    44,    45,    46,    47,    48,    49,   109,    50,    51,
    52,   110,   111,   112,   113,   116,    53,    85,    86,    54,
    55,    56,    57,    58,    59,   126,    60,    93,   127
};

static const short yypact[] = {   112,
    21,-32768,-32768,     7,    77,   139,-32768,    15,   219,-32768,
-32768,-32768,-32768,    10,-32768,-32768,-32768,-32768,-32768,-32768,
    19,-32768,    43,    47,    43,-32768,    17,    48,   302,   319,
   302,    64,-32768,-32768,-32768,-32768,-32768,-32768,    67,    73,
-32768,    84,   302,-32768,   231,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    70,   325,    80,    45,    66,-32768,-32768,
-32768,-32768,    93,-32768,    43,-32768,-32768,    68,   105,-32768,
   166,   103,   264,     4,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    99,    43,    19,    52,-32768,-32768,   166,   104,
-32768,   327,   109,-32768,   302,   302,    47,    78,   193,-32768,
-32768,   111,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   283,-32768,-32768,-32768,-32768,    12,-32768,-32768,   245,    43,
-32768,-32768,-32768,-32768,   302,    47,-32768,   327,-32768,-32768,
-32768,    80,-32768,    82,   302,   106,   106,-32768,-32768,-32768,
-32768,-32768,-32768,   110,-32768,    80,-32768,    82,-32768,-32768,
-32768,-32768,   125,   129,-32768
};

static const short yypgoto[] = {-32768,
   124,-32768,   135,-32768,-32768,   -19,-32768,   -51,   -29,    -4,
-32768,   -22,-32768,     6,   -18,-32768,   -67,-32768,-32768,    29,
-32768,   102,   -82,   -64,-32768,   -68,-32768,   116,-32768,-32768,
-32768,   118,-32768,    39,   122,-32768,-32768,-32768,-32768,-32768,
   -80,   -83,   -89,   -85,-32768,    95,-32768,-32768,    26
};


#define	YYLAST		348


static const short yytable[] = {    13,
    79,    65,    63,   104,    94,   115,   133,    69,   108,    62,
   134,   132,   130,   130,   131,   131,   114,    15,    64,    67,
    66,   122,    11,    10,   142,    11,    35,    12,    95,     3,
    61,   138,    16,    17,    35,    96,    18,    19,    90,     4,
   124,   146,   130,    79,   131,   133,   108,   143,   102,   148,
    70,   144,   130,    71,   131,   120,   121,    72,    11,    83,
   100,  -101,   125,    17,  -101,  -101,   119,    84,    15,    96,
   101,    18,    19,    87,   135,    88,   124,    15,    92,   118,
    94,    79,    17,    16,    17,    18,    19,    18,    19,    89,
   129,   129,    16,    17,    94,    16,    18,    19,   125,   136,
   137,    18,    19,   135,    95,    96,    98,   103,   105,   117,
   123,    -3,     1,   139,     2,   145,   -31,   128,    95,   -31,
   129,   -31,   152,   -31,   154,   149,     3,   -31,   155,   -31,
   129,    27,     4,   -31,   -31,   -31,   -31,   -31,    -2,     1,
    26,     2,   151,   -31,    91,    80,   -31,    81,   -31,   141,
   -31,    82,    97,   147,   -31,     0,   -31,     0,     0,     4,
   -31,   -31,   -31,   -31,   -31,   -36,    28,     0,   -36,     0,
    29,     0,     0,    30,     0,    31,     0,    32,   -36,     0,
     0,    11,     0,    33,     0,     0,     0,    34,    35,    36,
    37,    38,   -36,    28,     0,   -36,     0,    29,     0,     0,
    30,     0,    31,     0,    32,     0,     0,     0,    11,     0,
    33,     0,     0,     0,    34,    35,    36,    37,    38,    28,
     0,   -36,     0,    29,     0,     0,    30,     0,    31,     0,
    32,     0,     0,     0,    11,     0,    33,     0,     0,     0,
    34,    35,    36,    37,    38,    28,   -97,   -97,     0,    29,
   -97,   -97,    30,     0,    31,     0,    32,   -36,     0,     0,
    11,     0,    33,     0,     0,     0,    34,    35,    36,    37,
    38,    30,     0,    73,   107,    74,     0,     0,     0,    75,
    76,    33,    78,    18,    19,    34,    35,    36,    37,    38,
    30,     0,    73,   140,    74,     0,     0,     0,    75,    76,
    33,    78,    18,    19,    34,    35,    36,    37,    38,    30,
     0,    31,     0,    32,     0,     0,     0,    11,     0,    33,
     0,     0,     0,    34,    35,    36,    37,    38,    73,     0,
    74,     0,     0,     0,    75,    76,    77,    78,    18,    19,
   -98,   -98,    16,    17,   -98,   -98,    18,    19
};

static const short yycheck[] = {     4,
    30,    24,    21,    71,    56,    74,    96,    27,    73,    14,
    96,    95,    95,    96,    95,    96,    13,     1,    23,     3,
    25,    89,    16,     3,    13,    16,    23,    21,    58,    15,
    21,    99,    16,    17,    23,    58,    20,    21,    43,    21,
    92,   125,   125,    73,   125,   135,   111,   116,    68,   135,
     3,   119,   135,     6,   135,     4,    86,    29,    16,    31,
    65,    17,    92,    17,    20,    21,    85,     4,     1,    92,
     3,    20,    21,     7,    97,     3,   128,     1,     9,    84,
   132,   111,    17,    16,    17,    20,    21,    20,    21,     6,
    95,    96,    16,    17,   146,    16,    20,    21,   128,    22,
    23,    20,    21,   126,   134,   128,    14,     3,     6,    11,
     7,     0,     1,     3,     3,   120,     5,     9,   148,     8,
   125,    10,    13,    12,     0,    20,    15,    16,     0,    18,
   135,     8,    21,    22,    23,    24,    25,    26,     0,     1,
     6,     3,   137,     5,    43,    30,     8,    30,    10,   111,
    12,    30,    58,   128,    16,    -1,    18,    -1,    -1,    21,
    22,    23,    24,    25,    26,     0,     1,    -1,     3,    -1,
     5,    -1,    -1,     8,    -1,    10,    -1,    12,    13,    -1,
    -1,    16,    -1,    18,    -1,    -1,    -1,    22,    23,    24,
    25,    26,     0,     1,    -1,     3,    -1,     5,    -1,    -1,
     8,    -1,    10,    -1,    12,    -1,    -1,    -1,    16,    -1,
    18,    -1,    -1,    -1,    22,    23,    24,    25,    26,     1,
    -1,     3,    -1,     5,    -1,    -1,     8,    -1,    10,    -1,
    12,    -1,    -1,    -1,    16,    -1,    18,    -1,    -1,    -1,
    22,    23,    24,    25,    26,     1,    16,    17,    -1,     5,
    20,    21,     8,    -1,    10,    -1,    12,    13,    -1,    -1,
    16,    -1,    18,    -1,    -1,    -1,    22,    23,    24,    25,
    26,     8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
     8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,     8,
    -1,    10,    -1,    12,    -1,    -1,    -1,    16,    -1,    18,
    -1,    -1,    -1,    22,    23,    24,    25,    26,    10,    -1,
    12,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
    16,    17,    16,    17,    20,    21,    20,    21
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/dev/env/DJDIR/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/dev/env/DJDIR/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 100 "gst.y"
{ compileMethod(yyvsp[0].node); ;
    break;}
case 4:
#line 106 "gst.y"
{ clearMethodStartPos(); ;
    break;}
case 8:
#line 116 "gst.y"
{ skipCompilation = false; ;
    break;}
case 9:
#line 117 "gst.y"
{ skipCompilation = false; ;
    break;}
case 11:
#line 124 "gst.y"
{ if (yyvsp[-1].node && !hadError) {
					    executeStatements(yyvsp[-2].node, yyvsp[-1].node,
							    quietExecution); 
                                          }
					  hadError = false;
                                        ;
    break;}
case 12:
#line 130 "gst.y"
{ hadError = false;
					  yyerrok; ;
    break;}
case 13:
#line 135 "gst.y"
{ if (!hadError) {
					    if (skipCompilation) {
					      freeTree(yyvsp[-1].node);
					    } else {
					      compileMethod(yyvsp[-1].node);
					      clearMethodStartPos();
					    }
					  } else {
					    hadError = false;
					  }
					;
    break;}
case 14:
#line 146 "gst.y"
{ if (!hadError) {
					    if (skipCompilation) {
					      freeTree(yyvsp[-1].node);
					    } else {
					      compileMethod(yyvsp[-1].node);
					      clearMethodStartPos();
					    }
					  } else {
					    hadError = false;
					  }
					;
    break;}
case 15:
#line 161 "gst.y"
{ yyval.node = makeMethod(yyvsp[-3].node, yyvsp[-2].node, yyvsp[-1].ival, yyvsp[0].node); ;
    break;}
case 16:
#line 166 "gst.y"
{ yyval.node = makeUnaryExpr(nil, yyvsp[0].sval); ;
    break;}
case 17:
#line 167 "gst.y"
{ yyval.node = makeBinaryExpr(nil, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 18:
#line 168 "gst.y"
{ yyval.node = makeKeywordExpr(nil, yyvsp[0].node); ;
    break;}
case 19:
#line 169 "gst.y"
{ errorf("Invalid message pattern");
					  hadError = true;
					  /* 14-Jul-95 00:29:27 removed this yyerrok */
					  /* yyerrok; */
					  yyval.node = nil; ;
    break;}
case 23:
#line 186 "gst.y"
{ yyval.node = makeVariable(yyvsp[0].sval); ;
    break;}
case 24:
#line 190 "gst.y"
{ yyval.node = makeKeywordList(yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 25:
#line 192 "gst.y"
{ addNode(yyvsp[-2].node, makeKeywordList(yyvsp[-1].sval, yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 27:
#line 201 "gst.y"
{ yyval.ival = 0; ;
    break;}
case 28:
#line 202 "gst.y"
{ yyval.ival = yyvsp[-1].ival; ;
    break;}
case 29:
#line 203 "gst.y"
{ yyval.ival = yyvsp[-1].ival; ;
    break;}
case 30:
#line 206 "gst.y"
{ if (strcmp(yyvsp[0].sval, ">") != 0) YYFAIL; ;
    break;}
case 31:
#line 209 "gst.y"
{ yyval.node = nil; ;
    break;}
case 32:
#line 210 "gst.y"
{ yyval.node = nil; ;
    break;}
case 33:
#line 212 "gst.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 34:
#line 216 "gst.y"
{ yyval.node = makeVariableList(yyvsp[0].node); ;
    break;}
case 35:
#line 217 "gst.y"
{ addNode(yyvsp[-1].node, makeVariableList(yyvsp[0].node));
					  yyval.node = yyvsp[-1].node; ;
    break;}
case 36:
#line 222 "gst.y"
{ yyval.node = nil; ;
    break;}
case 38:
#line 228 "gst.y"
{ yyval.node = makeStatementList(makeReturn(yyvsp[-1].node),
				       			nil); ;
    break;}
case 39:
#line 230 "gst.y"
{ yyval.node = makeStatementList(yyvsp[0].node, nil); ;
    break;}
case 40:
#line 233 "gst.y"
{ yyval.node = makeStatementList(yyvsp[-2].node, yyvsp[0].node); ;
    break;}
case 41:
#line 234 "gst.y"
{ yyval.node = nil;
				  yyerrok;
				  hadError = true;
				;
    break;}
case 42:
#line 238 "gst.y"
{ yyval.node = yyvsp[0].node;
				  yyerrok;
				  hadError = true;
				;
    break;}
case 46:
#line 251 "gst.y"
{ yyval.node = makeAssign(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 47:
#line 255 "gst.y"
{ yyval.node = makeVariableList(yyvsp[-1].node); ;
    break;}
case 48:
#line 257 "gst.y"
{ addNode(yyvsp[-2].node, makeVariableList(yyvsp[-1].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 55:
#line 271 "gst.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 62:
#line 284 "gst.y"
{ yyval.node = makeIntConstant(yyvsp[0].ival); ;
    break;}
case 63:
#line 285 "gst.y"
{ yyval.node = makeFloatConstant(yyvsp[0].fval); ;
    break;}
case 64:
#line 286 "gst.y"
{ yyval.node = makeByteObjectConstant(yyvsp[0].boval); ;
    break;}
case 65:
#line 290 "gst.y"
{ yyval.node = makeIntConstant(yyvsp[0].ival); ;
    break;}
case 66:
#line 293 "gst.y"
{ yyval.node = makeSymbolConstant(yyvsp[0].node); ;
    break;}
case 67:
#line 294 "gst.y"
{ yyval.node = makeSymbolConstant(internIdent(yyvsp[0].sval)); ;
    break;}
case 68:
#line 298 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 69:
#line 299 "gst.y"
{ yyval.node = internBinOP(yyvsp[0].sval); ;
    break;}
case 70:
#line 300 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 71:
#line 301 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 72:
#line 306 "gst.y"
{ yyval.node = makeCharConstant(yyvsp[0].cval); ;
    break;}
case 73:
#line 310 "gst.y"
{ yyval.node = makeStringConstant(yyvsp[0].sval); ;
    break;}
case 74:
#line 314 "gst.y"
{ yyval.node = yyvsp[0].node; ;
    break;}
case 75:
#line 315 "gst.y"
{ yyval.node = yyvsp[0].node; ;
    break;}
case 76:
#line 319 "gst.y"
{ yyval.node = makeArrayConstant(nil); ;
    break;}
case 77:
#line 321 "gst.y"
{ yyval.node = makeArrayConstant(yyvsp[-1].node); ;
    break;}
case 78:
#line 325 "gst.y"
{ yyval.node = makeArrayElt(yyvsp[0].node); ;
    break;}
case 79:
#line 327 "gst.y"
{ addNode(yyvsp[-1].node, makeArrayElt(yyvsp[0].node));
					  yyval.node = yyvsp[-1].node; ;
    break;}
case 83:
#line 335 "gst.y"
{ yyval.node = makeSymbolConstant(yyvsp[0].node); ;
    break;}
case 84:
#line 339 "gst.y"
{ yyval.node = makeByteArrayConstant(nil); ;
    break;}
case 85:
#line 341 "gst.y"
{ yyval.node = makeByteArrayConstant(yyvsp[-1].node); ;
    break;}
case 86:
#line 345 "gst.y"
{ yyval.node = makeArrayElt(yyvsp[0].node); ;
    break;}
case 87:
#line 347 "gst.y"
{ addNode(yyvsp[-1].node, makeArrayElt(yyvsp[0].node));
					  yyval.node = yyvsp[-1].node; ;
    break;}
case 88:
#line 353 "gst.y"
{ yyval.node = makeBlock(yyvsp[-3].node, yyvsp[-2].node, yyvsp[-1].node); ;
    break;}
case 89:
#line 357 "gst.y"
{ yyval.node = nil; ;
    break;}
case 90:
#line 359 "gst.y"
{ if (yyvsp[0].sval[0] != '|') {
					    YYFAIL;
					  } else if (yyvsp[0].sval[1] == '\0') {	/* | */
					  } else if (yyvsp[0].sval[1] == '|') {   /* || */
					    unreadChar('|');
					  }
					;
    break;}
case 91:
#line 372 "gst.y"
{ yyval.node = makeVariableList(yyvsp[0].node); ;
    break;}
case 92:
#line 374 "gst.y"
{ addNode(yyvsp[-2].node, makeVariableList(yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 96:
#line 385 "gst.y"
{ yyval.node = makeUnaryExpr(yyvsp[-1].node, yyvsp[0].sval); ;
    break;}
case 99:
#line 395 "gst.y"
{ yyval.node = makeBinaryExpr(yyvsp[-2].node, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 102:
#line 405 "gst.y"
{ yyval.node = makeKeywordExpr(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 103:
#line 410 "gst.y"
{ yyval.node = makeKeywordList(yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 104:
#line 412 "gst.y"
{ addNode(yyvsp[-2].node, makeKeywordList(yyvsp[-1].sval, yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 105:
#line 418 "gst.y"
{ yyval.node = makeCascadedMessage(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 106:
#line 422 "gst.y"
{ yyval.node = makeMessageList(yyvsp[0].node); ;
    break;}
case 107:
#line 424 "gst.y"
{ addNode(yyvsp[-2].node, makeMessageList(yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 108:
#line 429 "gst.y"
{ yyval.node = makeUnaryExpr(nil, yyvsp[0].sval); ;
    break;}
case 109:
#line 431 "gst.y"
{ yyval.node = makeBinaryExpr(nil, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 110:
#line 433 "gst.y"
{ yyval.node = makeKeywordExpr(nil, yyvsp[0].node); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/dev/env/DJDIR/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 437 "gst.y"

/*     
 * ADDITIONAL C CODE
 */

